summaryrefslogtreecommitdiffstats
path: root/scripts/libmakepkg/util
diff options
context:
space:
mode:
authorEli Schwartz <eschwartz@archlinux.org>2020-06-02 23:50:24 +0200
committerAndrew Gregory <andrew@archlinux.org>2020-06-18 11:06:46 +0200
commitf4da297de252dcb00e6c83df00fea11c86606348 (patch)
treed822637c24449083791345eb57604c3ed433636c /scripts/libmakepkg/util
parent22e6daa79455b1c59ab73af9438ca0c1d2a884b9 (diff)
downloadpacman-f4da297de252dcb00e6c83df00fea11c86606348.tar.gz
pacman-f4da297de252dcb00e6c83df00fea11c86606348.tar.xz
libmakepkg: fix regression in sending plain() output to stderr
In commit 882e707e40bbade0111cf3bdedbdac4d4b70453b we changed message output to go to stdout by default, unless it was an error. The plain() function doesn't *look* like an error function, but in practice it was -- it's used to continue multiline messages, and all in-tree uses were for warning/error. This is a problem both because we're sending output to the wrong place, and because in some cases, we were performing error logging from a function which would otherwise return a value to be captured in a variable using command substution. Fix this and straighten out the API by providing two functions: one for continuing msg output, and one which wraps this by sending output to stderr, for continuing error output. Change all callers to use the second function. (cherry picked from commit bf458cced7c0845f7b6fabb887d3878ae4cd51b2)
Diffstat (limited to 'scripts/libmakepkg/util')
-rw-r--r--scripts/libmakepkg/util/config.sh.in2
-rw-r--r--scripts/libmakepkg/util/message.sh.in8
-rw-r--r--scripts/libmakepkg/util/source.sh.in4
-rw-r--r--scripts/libmakepkg/util/util.sh.in2
4 files changed, 12 insertions, 4 deletions
diff --git a/scripts/libmakepkg/util/config.sh.in b/scripts/libmakepkg/util/config.sh.in
index a8975d6d..ea909f84 100644
--- a/scripts/libmakepkg/util/config.sh.in
+++ b/scripts/libmakepkg/util/config.sh.in
@@ -39,7 +39,7 @@ source_makepkg_config() {
source_safe "$MAKEPKG_CONF"
else
error "$(gettext "%s not found.")" "$MAKEPKG_CONF"
- plain "$(gettext "Aborting...")"
+ plainerr "$(gettext "Aborting...")"
exit $E_CONFIG_ERROR
fi
diff --git a/scripts/libmakepkg/util/message.sh.in b/scripts/libmakepkg/util/message.sh.in
index 061bd858..625f11b1 100644
--- a/scripts/libmakepkg/util/message.sh.in
+++ b/scripts/libmakepkg/util/message.sh.in
@@ -43,12 +43,20 @@ colorize() {
readonly ALL_OFF BOLD BLUE GREEN RED YELLOW
}
+# plainerr/plainerr are primarily used to continue a previous message on a new
+# line, depending on whether the first line is a regular message or an error
+# output
+
plain() {
(( QUIET )) && return
local mesg=$1; shift
printf "${BOLD} ${mesg}${ALL_OFF}\n" "$@"
}
+plainerr() {
+ plain "$@" >&2
+}
+
msg() {
(( QUIET )) && return
local mesg=$1; shift
diff --git a/scripts/libmakepkg/util/source.sh.in b/scripts/libmakepkg/util/source.sh.in
index e0490661..be7c15c2 100644
--- a/scripts/libmakepkg/util/source.sh.in
+++ b/scripts/libmakepkg/util/source.sh.in
@@ -156,7 +156,7 @@ get_downloadclient() {
# if we didn't find an agent, return an error
if [[ -z $agent ]]; then
error "$(gettext "Unknown download protocol: %s")" "$proto"
- plain "$(gettext "Aborting...")"
+ plainerr "$(gettext "Aborting...")"
exit 1 # $E_CONFIG_ERROR
fi
@@ -165,7 +165,7 @@ get_downloadclient() {
if [[ ! -x $program ]]; then
local baseprog="${program##*/}"
error "$(gettext "The download program %s is not installed.")" "$baseprog"
- plain "$(gettext "Aborting...")"
+ plainerr "$(gettext "Aborting...")"
exit 1 # $E_MISSING_PROGRAM
fi
diff --git a/scripts/libmakepkg/util/util.sh.in b/scripts/libmakepkg/util/util.sh.in
index 8f6d6d3a..d1d11eb3 100644
--- a/scripts/libmakepkg/util/util.sh.in
+++ b/scripts/libmakepkg/util/util.sh.in
@@ -78,7 +78,7 @@ dir_is_empty() {
cd_safe() {
if ! cd "$1"; then
error "$(gettext "Failed to change to directory %s")" "$1"
- plain "$(gettext "Aborting...")"
+ plainerr "$(gettext "Aborting...")"
exit 1
fi
}